diff --git a/src/common/gui/COscillatorDisplay.cpp b/src/common/gui/COscillatorDisplay.cpp
index 1640c7e38..8affaa2e1 100644
--- a/src/common/gui/COscillatorDisplay.cpp
+++ b/src/common/gui/COscillatorDisplay.cpp
@@ -25,11 +25,37 @@ extern CFontRef displayFont;
 
 void COscillatorDisplay::draw(CDrawContext* dc)
 {
-   pdata tp[n_scene_params];
-   tp[oscdata->pitch.param_id_in_scene].f = 0;
-   for (int i = 0; i < n_osc_params; i++)
-      tp[oscdata->p[i].param_id_in_scene].i = oscdata->p[i].val.i;
-   Oscillator* osc = spawn_osc(oscdata->type.val.i, storage, oscdata, tp);
+   pdata tp[3][n_scene_params];
+   Oscillator *osces[3];
+   for( int c=0; c<3; ++c )
+   {
+       osces[c] = nullptr;
+       if( ! is_mod && c != 2 )
+           continue;
+       
+       tp[c][oscdata->pitch.param_id_in_scene].f = 0;
+       for (int i = 0; i < n_osc_params; i++)
+           tp[c][oscdata->p[i].param_id_in_scene].i = oscdata->p[i].val.i;
+
+       if( c != 2 )
+       {
+           auto modOut = ( c == 0 ? 1.0 : -1.0 );
+           auto activeScene = storage->getPatch().scene_active.val.i;
+           auto *scene = &(storage->getPatch().scene[activeScene]);
+           auto iter = scene->modulation_voice.begin();
+           
+           while (iter != scene->modulation_voice.end())
+           {
+               int src_id = iter->source_id;
+               int dst_id = iter->destination_id;
+               float depth = iter->depth;
+               tp[c][dst_id].f += depth * modOut; 
+               iter++;
+           }
+       }
+
+       osces[c] = spawn_osc(oscdata->type.val.i, storage, oscdata, tp[c]);
+   }
 
    int h = getHeight();
    if (uses_wavetabledata(oscdata->type.val.i))
@@ -40,7 +66,6 @@ void COscillatorDisplay::draw(CDrawContext* dc)
    int bottomline = midline + 0.4f * h;
 
 
-   CGraphicsPath *path = dc->createGraphicsPath();
    int totalSamples = ( 1 << 4 ) * (int)getWidth();
    int averagingWindow = 4; // this must be both less than BLOCK_SIZE_OS and BLOCK_SIZE_OS must be an integer multiple of it
 
@@ -49,112 +74,129 @@ void COscillatorDisplay::draw(CDrawContext* dc)
 #else
    float valScale = 100.0f;
 #endif
-   if (osc)
-   {
-      float disp_pitch_rs = disp_pitch + 12.0 * log2(dsamplerate / 44100.0);
-      bool use_display = osc->allow_display();
-
-      // Mis-install check #2
-      if (uses_wavetabledata(oscdata->type.val.i) && storage->wt_list.size() == 0)
-         use_display = false;
-
-      if (use_display)
-         osc->init(disp_pitch_rs, true);
-      
-      int block_pos = BLOCK_SIZE_OS;
-      for( int i=0; i<totalSamples; i += averagingWindow )
-      {
-          if (use_display && (block_pos >= BLOCK_SIZE_OS))
-          {
-              if (uses_wavetabledata(oscdata->type.val.i))
-              {
-                  storage->CS_WaveTableData.enter();
-                  osc->process_block(disp_pitch_rs);
-                  block_pos = 0;
-                  storage->CS_WaveTableData.leave();
-              }
-              else
-              {
-                  osc->process_block(disp_pitch_rs);
-                  block_pos = 0;
-              }
-          }
-
-          float val = 0.f;
-          if (use_display)
-          {
-              for( int j=0; j<averagingWindow; ++j ) {
-                  val += osc->output[block_pos];
-                  block_pos ++;
-              }
-              val = val / averagingWindow;
-              val = ( (-val+1.0f) * 0.5f * 0.8 + 0.1 ) * valScale;
-          }
-          block_pos++;
-          float xc = valScale * i / totalSamples;
-          
-          // OK so val is now a value between 0 and valScale, and xc is a value between 0 and valScale
-          if( i == 0 )
-          {
-              path->beginSubpath(xc, val);
-          }
-          else
-          {
-              path->addLine(xc, val);
-          }
-      }
-      delete osc;
-      // srand( (unsigned)time( NULL ) );
-   }
 
-   // OK so now we need to figure out how to transfer the box with is [0,valscale] x [0,valscale] to our coords.
-   // So scale then position
    auto size = getViewSize();
-   VSTGUI::CGraphicsTransform tf = VSTGUI::CGraphicsTransform()
-       .scale(getWidth()/valScale, h / valScale )
-       .translate(size.getTopLeft().x, size.getTopLeft().y );
+
+   for( int c=0; c<3; ++c )
+   {
+       Oscillator *osc = osces[c];
+       CGraphicsPath *path = dc->createGraphicsPath();
+       if (osc)
+       {
+           float disp_pitch_rs = disp_pitch + 12.0 * log2(dsamplerate / 44100.0);
+           bool use_display = osc->allow_display();
+           
+           // Mis-install check #2
+           if (uses_wavetabledata(oscdata->type.val.i) && storage->wt_list.size() == 0)
+               use_display = false;
+           
+           if (use_display)
+               osc->init(disp_pitch_rs, true);
+           
+           int block_pos = BLOCK_SIZE_OS;
+           for( int i=0; i<totalSamples; i += averagingWindow )
+           {
+               if (use_display && (block_pos >= BLOCK_SIZE_OS))
+               {
+                   if (uses_wavetabledata(oscdata->type.val.i))
+                   {
+                       storage->CS_WaveTableData.enter();
+                       osc->process_block(disp_pitch_rs);
+                       block_pos = 0;
+                       storage->CS_WaveTableData.leave();
+                   }
+                   else
+                   {
+                       osc->process_block(disp_pitch_rs);
+                       block_pos = 0;
+                   }
+               }
+               
+               float val = 0.f;
+               if (use_display)
+               {
+                   for( int j=0; j<averagingWindow; ++j ) {
+                       val += osc->output[block_pos];
+                       block_pos ++;
+                   }
+                   val = val / averagingWindow;
+                   val = ( (-val+1.0f) * 0.5f * 0.8 + 0.1 ) * valScale;
+               }
+               block_pos++;
+               float xc = valScale * i / totalSamples;
+               
+               // OK so val is now a value between 0 and valScale, and xc is a value between 0 and valScale
+               if( i == 0 )
+               {
+                   path->beginSubpath(xc, val);
+               }
+               else
+               {
+                   path->addLine(xc, val);
+               }
+           }
+           // srand( (unsigned)time( NULL ) );
+       }
+       // OK so now we need to figure out how to transfer the box with is [0,valscale] x [0,valscale] to our coords.
+       // So scale then position
+       VSTGUI::CGraphicsTransform tf = VSTGUI::CGraphicsTransform()
+           .scale(getWidth()/valScale, h / valScale )
+           .translate(size.getTopLeft().x, size.getTopLeft().y );
 #if LINUX
-   auto tmps = size;
-   dc->getCurrentTransform().transform(tmps);
-   VSTGUI::CGraphicsTransform tpath = VSTGUI::CGraphicsTransform()
-       .scale(getWidth()/valScale, h / valScale )
-       .translate(tmps.getTopLeft().x, tmps.getTopLeft().y );
+       auto tmps = size;
+       dc->getCurrentTransform().transform(tmps);
+       VSTGUI::CGraphicsTransform tpath = VSTGUI::CGraphicsTransform()
+           .scale(getWidth()/valScale, h / valScale )
+           .translate(tmps.getTopLeft().x, tmps.getTopLeft().y );
 #else
-   auto tpath = tf;
+       auto tpath = tf;
 #endif
-
-   dc->saveGlobalState();
-
-   // OK so draw the rules
-   CPoint mid0(0, valScale/2.f), mid1(valScale,valScale/2.f);
-   CPoint top0(0, valScale * 0.9), top1(valScale,valScale * 0.9);
-   CPoint bot0(0, valScale * 0.1), bot1(valScale,valScale * 0.1);
-   tf.transform(mid0);
-   tf.transform(mid1);
-   tf.transform(top0);
-   tf.transform(top1);
-   tf.transform(bot0);
-   tf.transform(bot1);
-   dc->setDrawMode(VSTGUI::kAntiAliasing);
-
-   dc->setLineWidth(1.0);
-   dc->setFrameColor(VSTGUI::CColor(90,90,90));
-   dc->drawLine(mid0, mid1);
-
-   dc->setLineWidth(1.0);
-   dc->setFrameColor(VSTGUI::CColor(70,70,70));
-   dc->drawLine(top0, top1);
-   dc->drawLine(bot0, bot1);
-
+       
+       dc->saveGlobalState();
+
+       if( c == 0 )
+       {
+           // OK so draw the rules
+           CPoint mid0(0, valScale/2.f), mid1(valScale,valScale/2.f);
+           CPoint top0(0, valScale * 0.9), top1(valScale,valScale * 0.9);
+           CPoint bot0(0, valScale * 0.1), bot1(valScale,valScale * 0.1);
+           tf.transform(mid0);
+           tf.transform(mid1);
+           tf.transform(top0);
+           tf.transform(top1);
+           tf.transform(bot0);
+           tf.transform(bot1);
+           dc->setDrawMode(VSTGUI::kAntiAliasing);
+           
+           dc->setLineWidth(1.0);
+           dc->setFrameColor(VSTGUI::CColor(90,90,90));
+           dc->drawLine(mid0, mid1);
+           
+           dc->setLineWidth(1.0);
+           dc->setFrameColor(VSTGUI::CColor(70,70,70));
+           dc->drawLine(top0, top1);
+           dc->drawLine(bot0, bot1);
+       }
+       
 #if LINUX
-   dc->setLineWidth(130);
+       dc->setLineWidth(130);
 #else
-   dc->setLineWidth(1.3);
+       dc->setLineWidth(1.3);
 #endif
-   dc->setFrameColor(VSTGUI::CColor(0xFF, 0x90, 0, 0xFF));
-   dc->drawGraphicsPath(path, VSTGUI::CDrawContext::PathDrawMode::kPathStroked, &tpath );
-   dc->restoreGlobalState();
-   path->forget();
+       dc->setDrawMode(VSTGUI::kAntiAliasing);
+       if( c == 0 )
+           dc->setFrameColor(VSTGUI::CColor(180, 100, 30, 0xFF));
+       else if( c == 1 )
+           dc->setFrameColor(VSTGUI::CColor(100, 100, 180, 0xFF));
+       else
+           dc->setFrameColor(VSTGUI::CColor(0xFF, 0x90, 0, 0xFF));
+       dc->drawGraphicsPath(path, VSTGUI::CDrawContext::PathDrawMode::kPathStroked, &tpath );
+       dc->restoreGlobalState();
+
+       path->forget();
+
+       delete osces[c];
+   }
    
    if (uses_wavetabledata(oscdata->type.val.i))
    {
diff --git a/src/common/gui/COscillatorDisplay.h b/src/common/gui/COscillatorDisplay.h
index 644834149..f83973846 100644
--- a/src/common/gui/COscillatorDisplay.h
+++ b/src/common/gui/COscillatorDisplay.h
@@ -52,6 +52,8 @@ class COscillatorDisplay : public VSTGUI::CControl, public VSTGUI::IDropTarget
    virtual VSTGUI::CMouseEventResult onMouseUp(VSTGUI::CPoint& where, const VSTGUI::CButtonState& buttons);
    virtual VSTGUI::CMouseEventResult onMouseMoved(VSTGUI::CPoint& where, const VSTGUI::CButtonState& buttons);
 
+   void setIsMod(bool b) { is_mod = b; }
+   
 protected:
    void populateMenu(VSTGUI::COptionMenu* m, int selectedItem);
    bool populateMenuForCategory(VSTGUI::COptionMenu* parent, int categoryId, int selectedItem);
@@ -61,6 +63,7 @@ class COscillatorDisplay : public VSTGUI::CControl, public VSTGUI::IDropTarget
    unsigned controlstate;
 
    bool doingDrag = false;
+   bool is_mod = false;
    VSTGUI::CRect rnext, rprev, rmenu;
    VSTGUI::CPoint lastpos;
    CLASS_METHODS(COscillatorDisplay, VSTGUI::CControl)
diff --git a/src/common/gui/SurgeGUIEditor.cpp b/src/common/gui/SurgeGUIEditor.cpp
index 9a08d8ac0..b97e82814 100644
--- a/src/common/gui/SurgeGUIEditor.cpp
+++ b/src/common/gui/SurgeGUIEditor.cpp
@@ -495,6 +495,12 @@ void SurgeGUIEditor::refresh_mod()
          s->invalid();
       }
    }
+   if( oscdisplay )
+   {
+       ((COscillatorDisplay*)oscdisplay)->setIsMod(mod_editor);
+       oscdisplay->invalid();
+       oscdisplay->setDirty(true);
+   }
    synth->storage.CS_ModRouting.leave();
    for (int i = 1; i < n_modsources; i++)
    {
